// BSPTree.java

class BSPTree 
{
    BSPTree front,back;
    Object3d obj;
    Face3d plane;

    BSPTree(Face3d plane, BSPTree back, Object3d obj, BSPTree front)
    {
        this.front = front;
        this.obj   = obj;
        this.back  = back;
        this.plane = plane;
    }

    BSPTree(Face3d plane, BSPTree back, BSPTree front)
    {
        this.front = front;
        this.obj   = null;
        this.back  = back;
        this.plane = plane;
    }

    BSPTree(Object3d obj)
    {
        this.front = null;
        this.obj   = obj;
        this.back  = null;
        this.plane = null;
    }

    void setPaintOrder(Model3d md)
    {
        setPaintOrder(md.obj, md.nobj, 0);
    }

    int setPaintOrder(Object3d obj[], int nobj, int cobj)
    {
        if (plane == null)
        {
            if (cobj >= nobj)
                return cobj;
            if (this.obj != null)
                obj[cobj++] = this.obj;
        }
        else if (plane.visible())
        {
            if (back != null)
                cobj = back.setPaintOrder(obj,nobj,cobj);
            if (cobj >= nobj)
                return cobj;
            if (this.obj != null)
                obj[cobj++] = this.obj;
            if (front != null)
                cobj = front.setPaintOrder(obj,nobj,cobj);
        } 
        else
        {
            if (front != null)
                cobj = front.setPaintOrder(obj,nobj,cobj);
            if (cobj >= nobj)
                return cobj;
            if (this.obj != null)
                obj[cobj++] = this.obj;
            if (back != null)
                cobj = back.setPaintOrder(obj,nobj,cobj);
        } 
        return cobj;
    }

}
