// Position.java

class Position 
{
    Matrix3d rot, scale, trans;

    Position()
    {
        rot   = new Matrix3d();
        scale = new Matrix3d();
        trans = new Matrix3d();
    }

    Position(Position p)
    {
        this();
        copyPos(p);
    }

    void copyPos(Position p)
    {
        rot.copy(p.rot);
        scale.copy(p.scale);
        trans.copy(p.trans);
    }   

    void setRot(float rx, float ry, float rz)
    { 
        rot.unit();
        incRot(rx, ry, rz);
    }

    void setScale(float sx, float sy, float sz)
    { 
        scale.unit();
        incScale(sx, sy, sz);
    }

    void setTrans(float tx, float ty, float tz)
    { 
        trans.unit();
        incTrans(tx, ty, tz);
    }

    void incRot(float rx, float ry, float rz)
    {
        if (rx != 0)
            rot.xrot(rx);
        if (ry != 0)
            rot.yrot(ry);
        if (rz != 0)
            rot.zrot(rz);
    }

    void incScale(float sx, float sy, float sz)
    {
        scale.scale(sx, sy, sz);
    }

    void incTrans(float tx, float ty, float tz)
    {
        trans.trans(tx, ty, tz);
    }

}
