// TestBrowser.java

import java.applet.Applet;
import java.awt.Color;

public class TestBrowser extends Browser3d
{
    public void init()
    {
        md = new CastleBSP(this, size().width, size().height);
        super.init();
    }

}

class CastleBSP extends Castle
{
    BSPTree tree;
    Cube dummy;

    CastleBSP(Applet app, int width, int height) 
    {
        super(app, width, height);
        dummy = new Cube(this,12);
        dummy.setDummy(true);
        cyl[0].setName("RedCylinder");
        cyl[0].setColor(Color.red);
        con[0].setName("RedCone");
        con[0].setColor(Color.red);
        cyl[1].setName("YellowCylinder");
        cyl[1].setColor(Color.yellow);
        con[1].setName("YellowCone");
        con[1].setColor(Color.yellow);
        cyl[2].setName("PinkCylinder");
        cyl[2].setColor(Color.pink);
        con[2].setName("PinkCone");
        con[2].setColor(Color.pink);
        cyl[3].setName("OrangeCylinder");
        cyl[3].setColor(Color.orange);
        con[3].setName("OrangeCone");
        con[3].setColor(Color.orange);
        sph.setName("Sphere");
        setRot(90,0,0);
        nobj++;
        cobj++;
        Object3d temp[] = obj;
        obj = new Object3d[nobj];
        obj[0] = dummy;
        for (int i = 1; i < nobj; i++)
            obj[i] = temp[i-1];
        Face3d f_z = dummy.face[0];
        Face3d fz  = dummy.face[1];
        Face3d f_y = dummy.face[2];
        Face3d fy  = dummy.face[3];
        Face3d f_x = dummy.face[4];
        Face3d fx  = dummy.face[5];
        BSPTree t0 = new BSPTree(cyl[0].face[0], new BSPTree(cyl[0]), con[0], null);
        BSPTree t1 = new BSPTree(cyl[1].face[0], new BSPTree(cyl[1]), con[1], null);
        BSPTree t2 = new BSPTree(cyl[2].face[0], new BSPTree(cyl[2]), con[2], null);
        BSPTree t3 = new BSPTree(cyl[3].face[0], new BSPTree(cyl[3]), con[3], null);
        BSPTree tm = new BSPTree(fx, new BSPTree(f_x, null, sph, t2), null, t0);
        tree = new BSPTree(fy, new BSPTree(f_y, tm, null, t3), null, t1);
    }

    void setPaintOrder()
    {
        tree.setPaintOrder(obj,nobj,1);
    }

    void move()
    {
    }

}
