// TestObj.java

import java.applet.Applet;
import java.awt.Color;

public class TestObj extends Animation
{
    Model3d createModel()
    {
        return new Castle(this, size().width, size().height);
    }
}

class Castle extends Model3d
{
    Cylinder cyl[];
    Cone con[];
    Sphere sph;
    float rotation;
    static final float defaultRotation = 5.0f;

    Castle(Applet app, int width, int height) 
    {
        super(app,width,height,9);
        rotation = param("rotation",defaultRotation);

        int   nt =  4;
        int   nv = 16;
        float r  =  6;
        float q  =  2;
        float h  =  8;
        Matrix3d m = new Matrix3d();
        m.zrot(90);

        cyl = new Cylinder[nt];
        Vector3d vcyl = new Vector3d(r+q,0,0);
        for (int i = 0; i < nt; i++)
        {
            cyl[i] = new Cylinder(this,q,nv,-h);
            cyl[i].setTrans(vcyl.x, vcyl.y, vcyl.z);
            m.transform(vcyl, vcyl);
            addObject(cyl[i]);
        }

        con = new Cone[nt];
        Vector3d vcon = new Vector3d(r+q,0,0);
        for (int i = 0; i < nt; i++)
        {
            con[i] = new Cone(this,q,nv,h);
            con[i].setTrans(vcon.x, vcon.y, vcon.z);
            m.transform(vcon, vcon);
            addObject(con[i]);
        }

        sph = new Sphere(this,r,10,16);
        sph.setRot(-45,-45,-45);
        addObject(sph);

        setRot(90,0,0);
    }

    void move()
    {
        incRot(0,rotation,0);
    }

}
