// TestStudio.java

import java.applet.Applet;
import java.awt.Color;

public class TestStudio extends Studio3d
{
    Model3d createModel()
    {
        return new OneCylinderOneCone(this, size().width, size().height);
    }
}

class OneCylinderOneCone extends Model3d
{
    Cylinder cyl;
    Cone con;
    Cube dummy;
    private final int n = 10;
    private final int p = 80;
    private final float r = 1;
    private final float h = 4;
    int frame = 0;
    float dy = r / 10;

    OneCylinderOneCone(Applet app, int width, int height)
    {
        super(app, width, height, 3);
        float x = p * dy / 2;
        cyl = new Cylinder(this, r, n, h);
        cyl.setColor(Color.red);
        cyl.setTrans(-x/2, -x, -h/2);
        addObject(cyl);
        con = new Cone(this, r, n, h);
        con.setColor(Color.green);
        con.setTrans(x/2, x, -h/2);
        addObject(con);
        dummy = new Cube(this, x*2);
        dummy.setDummy(true);
        addObject(dummy);
    }

    void move()
    {
        cyl.incTrans(0, dy, 0);
        con.incTrans(0, -dy, 0);
        frame++;
        if (frame % p == 0)
        {
            frame = 0;
            dy = -dy;
        }
    }

}
